//+------------------------------------------------------------------+
//|                                                    GapSeeker.mq4 |
//|                                         Copyright  2010, Wolfe. |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Wolfe."
#property link      "http://www.forex-tsd.com "

#include <stderror.mqh>
#include <stdlib.mqh>

extern double Stop_Variable   = 3.5;//multiply gap by this number for stoploss
extern int    Profit_Variable = 1;//takeprofit will be Fri close - spread - this number
extern double Lot_Size        = 0.1;
extern int    Magic_Number    = 44648;

bool   GapTrap, TradeSet, ShowComm;

double symspread;

double StopLoss, TakeProfit, gslv;

int LG;

int    Var           = 1;

string sym = " ";

#define Array_Length 100
double close[Array_Length];                         
                                        
void ClearClose()                             
  {                                                   
    for ( int i = Array_Length-1; i >= 0; i-- )      
    close[i] = 0;                            
  }
       
#define Array_LengthII 100
double gaps[Array_LengthII];                         
                                        
void ClearGaps()                             
  {                                                   
    for ( int i = Array_LengthII-1; i >= 0; i-- )      
    gaps[i] = 0;                            
  }
  
#define Array_LengthIII 100
double open[Array_LengthIII];                         
                                        
void ClearOpen()                             
  {                                                   
    for ( int i = Array_LengthIII-1; i >= 0; i-- )      
    open[i] = 0;                            
  }

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  
    Alert("ONLY ATTACH ON SUNDAY WHEN MARKET IS CLOSED!!!");
    
    ClearGaps();
    ClearClose();
    ClearOpen();
    
    GapTrap = true;
    TradeSet = true;
    ShowComm = true;
    
    close[0]  = MarketInfo("EURUSD",MODE_BID);//Index 0
    close[1]  = MarketInfo("USDJPY",MODE_BID);//Index 1
    close[2]  = MarketInfo("GBPUSD",MODE_BID);//Index 2
    close[3]  = MarketInfo("USDCHF",MODE_BID);//Index 3
    close[4]  = MarketInfo("USDCAD",MODE_BID);//Index 4
    close[5]  = MarketInfo("AUDUSD",MODE_BID);//Index 5
    close[6]  = MarketInfo("NZDUSD",MODE_BID);//Index 6
    close[7]  = MarketInfo("EURGBP",MODE_BID);//Index 7
    close[8]  = MarketInfo("EURJPY",MODE_BID);//Index 8
    close[9]  = MarketInfo("EURCHF",MODE_BID);//Index 9
    close[10] = MarketInfo("GBPCHF",MODE_BID);//Index 10
    close[11] = MarketInfo("AUDJPY",MODE_BID);//Index 11
    close[12] = MarketInfo("CHFJPY",MODE_BID);//Index 12
    close[13] = MarketInfo("EURCAD",MODE_BID);//Index 13
    close[14] = MarketInfo("EURAUD",MODE_BID);//Index 14
    close[15] = MarketInfo("AUDCAD",MODE_BID);//Index 15
    close[16] = MarketInfo("AUDNZD",MODE_BID);//Index 16
    close[17] = MarketInfo("NZDJPY",MODE_BID);//Index 17
    close[18] = MarketInfo("GBPJPY",MODE_BID);//Index 18
    
    
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(GapTrap == true)
   {
    open[0]  = MarketInfo("EURUSD",MODE_BID);
    open[1]  = MarketInfo("USDJPY",MODE_BID);
    open[2]  = MarketInfo("GBPUSD",MODE_BID);
    open[3]  = MarketInfo("USDCHF",MODE_BID);
    open[4]  = MarketInfo("USDCAD",MODE_BID);
    open[5]  = MarketInfo("AUDUSD",MODE_BID);
    open[6]  = MarketInfo("NZDUSD",MODE_BID);
    open[7]  = MarketInfo("EURGBP",MODE_BID);
    open[8]  = MarketInfo("EURJPY",MODE_BID);
    open[9]  = MarketInfo("EURCHF",MODE_BID);
    open[10] = MarketInfo("GBPCHF",MODE_BID);
    open[11] = MarketInfo("AUDJPY",MODE_BID);
    open[12] = MarketInfo("CHFJPY",MODE_BID);
    open[13] = MarketInfo("EURCAD",MODE_BID);
    open[14] = MarketInfo("EURAUD",MODE_BID);
    open[15] = MarketInfo("AUDCAD",MODE_BID);
    open[16] = MarketInfo("AUDNZD",MODE_BID);
    open[17] = MarketInfo("NZDJPY",MODE_BID);
    open[18] = MarketInfo("GBPJPY",MODE_BID);
    
    gaps[0]=  (open[0]  - close[0])*10000;
    gaps[1]=  (open[1]  - close[1])*100;
    gaps[2]=  (open[2]  - close[2])*10000;
    gaps[3]=  (open[3]  - close[3])*10000;
    gaps[4]=  (open[4]  - close[4])*10000;
    gaps[5]=  (open[5]  - close[5])*10000;
    gaps[6]=  (open[6]  - close[6])*10000;
    gaps[7]=  (open[7]  - close[7])*10000;
    gaps[8]=  (open[8]  - close[8])*100;
    gaps[9]=  (open[9]  - close[9])*10000;
    gaps[10]= (open[10] - close[10])*10000;
    gaps[11]= (open[11] - close[11])*100;
    gaps[12]= (open[12] - close[12])*100;
    gaps[13]= (open[13] - close[13])*10000;
    gaps[14]= (open[14] - close[14])*10000;
    gaps[15]= (open[15] - close[15])*10000;
    gaps[16]= (open[16] - close[16])*10000;
    gaps[17]= (open[17] - close[17])*100;
    gaps[18]= (open[18] - close[18])*100;
    
    LG = LargestGap();
   
    sym = TradeSymbol(LG);
   
    symspread = MarketInfo(sym,MODE_SPREAD);
    
    if(gaps[LG] > 0)
     {
      gslv = gaps[LG];
     }
     
    if(gaps[LG] < 0)
     {
      gslv = gaps[LG]*(-1);
     }
     
    GapTrap = false;
   }
   
   if((gaps[LG] < 0) && (TradeSet == true))//we buy
    {
     StopLoss = (open[LG] - (MathRound((gslv*Stop_Variable))* MarketInfo(sym,MODE_POINT)));
     TakeProfit = close[LG] - ((symspread+Profit_Variable)*MarketInfo(sym,MODE_POINT));
     Print("Long Order For ",sym,"  StopLoss =  ",StopLoss,"   TakeProfit =  ",TakeProfit);
     SendLong(sym, Lot_Size, StopLoss, TakeProfit, Magic_Number);
    }
    
   if((gaps[LG] > 0) && (TradeSet == true))//we sell
    {
     StopLoss = (close[LG] + (MathRound((gslv*Stop_Variable))*MarketInfo(sym,MODE_POINT)));
     TakeProfit = open[LG] + ((symspread+Profit_Variable)*MarketInfo(sym,MODE_POINT));
     Print("Short Order For ",sym,"  StopLoss =  ",StopLoss,"   TakeProfit =  ",TakeProfit);
     SendShort(sym, Lot_Size, StopLoss, TakeProfit, Magic_Number);
    }
   
   if(ShowComm == true)
   {
   Comment("\nLargest Gap =  ",sym,"  Gap =  ",gaps[LG],"  Spread =  ",symspread,
           "\n",
           "\n",sym,"  Open =  ",open[LG],"  Close =  ",close[LG],
           "\n",
           "\nStopLoss =  ",StopLoss,"  TakeProfit =  ",TakeProfit,
           "\n",
           "\ntst =  ",(MathRound((gslv*Stop_Variable))*MarketInfo(sym,MODE_POINT)));
    ShowComm = false;
   } 
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+



int LargestGap()
 {
  double cg=0;//current gap
  double lg=0;//largest gap
  int y = 99;
  for (int i = 0; i <= 20; i++)
   {
    cg = MathAbs(gaps[i]);
    if((cg > lg) && (cg > (MarketInfo(TradeSymbol(i),MODE_SPREAD)+Var)))
     {
      y = i;
     }
   }
  return(y);
 }

string TradeSymbol(int x)
 {
  string y;
  if(x == 0)  y = "EURUSD";
  if(x == 1)  y = "USDJPY";
  if(x == 2)  y = "GBPUSD";
  if(x == 3)  y = "USDCHF";
  if(x == 4)  y = "USDCAD";
  if(x == 5)  y = "AUDUSD";
  if(x == 6)  y = "NZDUSD";
  if(x == 7)  y = "EURGBP";
  if(x == 8)  y = "EURJPY";
  if(x == 9)  y = "EURCHF";
  if(x == 10) y = "GBPCHF";
  if(x == 11) y = "AUDJPY";
  if(x == 12) y = "CHFJPY";
  if(x == 13) y = "EURCAD";
  if(x == 14) y = "EURAUD";
  if(x == 15) y = "AUDCAD";
  if(x == 16) y = "AUDNZD";
  if(x == 17) y = "NZDJPY";
  if(x == 18) y = "GBPJPY";
  if(x == 99) y = "NO TRADEABLE GAP";
  return(y);
 }
 
//+-----------------------------------------------------------------------------------------------+//
//+-----------------------------------------------------------------------------------------------+//
 
int OTBM(int intMagic)//OrdersTotalByMagic
{
int intCount=0;
int intPOS=0;
bool boolTerm=false;
while(boolTerm==false)
{
if(OrderSelect(intPOS,SELECT_BY_POS))
{
if(OrderMagicNumber()==intMagic) intCount++;
intPOS++;
}
else
boolTerm=true;
}
return(intCount);
}
 
//+-----------------------------------------------------------------------------------------------+//
//+-----------------------------------------------------------------------------------------------+//

void SendLong(string pair, double lots, double SL, double TP, int magic)//Send Long
{
 
 if (OTBM(magic) ==0)
  {
   int err;
   OrderSend(pair,OP_BUY,lots,MarketInfo(pair,MODE_ASK),0,SL,TP,"Long",magic,0,Green);
   err = GetLastError();
   Print("             ERROR(",err,"):  ",ErrorDescription(err));
   Sleep(200);
   if (OTBM(magic) == 1)
    {
     TradeSet = false;
    }
  }
}

//+-----------------------------------------------------------------------------------------------+//
//+-----------------------------------------------------------------------------------------------+//

void SendShort(string pair, double lots, double SL, double TP, int magic)//Send Short
{
 if (OTBM(magic) ==0)
  {
   int err;
   OrderSend(pair,OP_SELL,lots,MarketInfo(pair,MODE_BID),0,SL,TP,"Short",magic,0,Red);
   err = GetLastError();
   Print("             ERROR(",err,"):  ",ErrorDescription(err));
   Sleep(200);
   if (OTBM(magic) == 1)
    {
     TradeSet = false;
    }
  }
}

// 


